All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 [ -n "$VCSH_DEBUG" ] && set -x
4 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
5 [ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
8 if [ "$SELF" = 'bash' ] ||
9 [ "$SELF" = 'dash' ] ||
11 [ "$SELF" = 'zsh' ]; then
18 echo "usage: $SELF <args>
21 [<repo>] Clone from an existing repository
22 help Display this help text
23 delete Delete an existing repository
24 enter Enter repository; spawn new $SHELL
25 exit Exit repository; unset ENV
26 init <repo> Initialize a new repository
27 list List all repositories
29 <command> Use this repository
32 <repo> Seed .gitignore.d/<repo> from git ls-files
33 use <repo> Use repository; set ENV
35 <repo> <git command> Special command that allows you to run git commands
36 directly without having to type so much ;)" >&2
40 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
44 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
49 if [ ! -d "$GIT_DIR" ]; then
50 echo E: no repository found for "$VCSH_REPO_NAME" >&2
54 export GIT_WORK_TREE="$(git config --get core.worktree)"
55 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
60 verbose "init() begin"
62 echo "$SELF: fatal: $GIT_DIR exists" &&
64 export GIT_WORK_TREE="$HOME"
65 mkdir -p "$GIT_WORK_TREE"
66 cd "$GIT_WORK_TREE" ||
67 (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
68 return 1) || return $?
71 git config core.worktree "$GIT_WORK_TREE"
72 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
73 touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
74 git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
85 if [ "$1" = 'clone' ]; then
86 export VCSH_COMMAND="$1"
90 [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
92 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
93 elif [ "$1" = 'delete' ] ||
97 [ "$1" = 'seed-gitignore' ] ||
98 [ "$1" = 'use' ]; then
99 [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
100 export VCSH_COMMAND="$1"
101 export VCSH_REPO_NAME="$2"
102 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
104 export VCSH_EXTERNAL_COMMAND="$*"
105 if [ "$VCSH_COMMAND" = 'run' ]; then
106 [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
108 elif [ "$1" = 'exit' ] ||
110 [ "$1" = 'list' ]; then
111 export VCSH_COMMAND="$1"
113 [ -z $1 ] && help && return 0
114 export VCSH_COMMAND='run'
115 export VCSH_REPO_NAME="$1"
116 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
117 [ -d $GIT_DIR ] || (help && return 1) || return 0
119 export VCSH_EXTERNAL_COMMAND="git $*"
123 for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
125 if [ ! -d "$check_directory" ]; then
126 if [ -e "$check_directory" ]; then
127 echo "$SELF: error: $check_directory exists but is not a directory" >&2
130 echo "$SELF: info: attempting to create $check_directory"
131 mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
137 if [ "$VCSH_COMMAND" = 'clone' ]; then
138 verbose "clone begin"
140 git remote add origin "$GIT_REMOTE"
141 git config branch.master.remote origin
142 git config branch.master.merge refs/heads/master
144 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
146 echo "$SELF: error: $object exists." &&
149 [ "$VCSH_CONFLICT" = '1' ] &&
150 echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
151 echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
153 git merge origin/master
157 #elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
158 elif [ "$VCSH_COMMAND" = 'help' ]; then
161 elif [ "$VCSH_COMMAND" = 'delete' ]; then
162 verbose "delete begin"
166 echo "$SELF: info: This operation WILL DETROY DATA!"
167 files=$(git ls-files)
168 echo "These files will be deleted:
172 AGAIN, THIS WILL DELETE YOUR DATA!
173 To continue, type \"Yes, do as I say\""
175 [ "x$answer" = "xYes, do as I say" ] || return 1
176 for file in $files; do
177 rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
179 rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
183 elif [ "$VCSH_COMMAND" = 'enter' ]; then
184 verbose "enter begin"
190 elif [ "$VCSH_COMMAND" = 'exit' ]; then
192 # if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
193 # unset VCSH_NO_IGNORE_EOF
194 # setopt NO_IGNORE_EOF
196 [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
198 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
202 elif [ "$VCSH_COMMAND" = 'init' ]; then
208 elif [ "$VCSH_COMMAND" = 'list' ]; then
210 for i in "$VCSH_BASE"/*.git; do
211 echo $(basename "$i" .git)
215 elif [ "$VCSH_COMMAND" = 'run' ]; then
218 $VCSH_EXTERNAL_COMMAND
222 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
223 verbose "seed-gitignore begin"
225 # Switching directory as this has to be executed from $HOME to be of any use.
226 # Going back into old directory at the end in case `vcsh use` is reactivated.
229 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
230 gitignores=$(for file in $(git ls-files); do
232 echo $file; new="${file%/*}"
233 [ "$file" = "$new" ] && break
237 tempfile=$(mktemp) ||
238 (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
239 echo '*' > "$tempfile"
240 for gitignore in $gitignores; do
241 echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
242 [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
244 diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
247 if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
248 echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
249 mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
250 (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
251 return 1) || return $?
253 mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
254 (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
256 verbose "seed-gitignore end"
258 elif [ "$VCSH_COMMAND" = 'use' ]; then
260 # if [ -n "$ZSH_VERSION" ]; then
261 # if [ -o NO_IGNORE_EOF ]; then
262 # export VCSH_NO_IGNORE_EOF=1
270 # bindkey '^d' 'vcsh_exit'
272 [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
274 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
278 verbose "defaulting to calling help()"
280 echo "$SELF: fatal: You should never reach this code. File a bug, please."